<?php

class Media extends Core {

    public function __construct(&$db) {
        $this->db = $db;
    }

    //przycinanie tekstu
    private function truncateString($str, $chars, $to_space, $replacement = "") {
        if ($chars > strlen($str))
            return $str;

        $str = substr($str, 0, $chars);
        $space_pos = strrpos($str, " ");
        if ($to_space && $space_pos >= 0)
            $str = substr($str, 0, strrpos($str, " "));

        return($str . $replacement);
    }

    //czy plik o tej nazwie istnieje
    private function is_name($user_id, $f_shortname) {
        $query = "SELECT count(*) as total FROM files WHERE user_id='$user_id' AND f_sname='$f_shortname' ";
        $result = $this->db->sql_query($query);
        if ($result) {
            $row = $this->db->sql_fetcharray($result);
            $total = $row['total'];
        }
        //jesli istnieje    
        if ($total > 0) {
            return true;
        }
        //jesli nieistnieje
        else {
            return false;
        }
    }

    //zapisanie pliku na serwer
    public function save($user, $file) {
        $name = $file['file']['name'];
        $mime = $file['file']['type'];
        //$data = addslashes(file_get_contents($file['file']['tmp_name']));
        $data = (file_get_contents($file['file']['tmp_name']));
        $size = intval($file['file']['size']);

        $uspass = $_COOKIE['password'];
        $ckey = $user['ckey'];
        $user_id = $user['user_id'];
        $data = $this->DataCrypt($data, $uspass, $ckey);

        //short nazwa
        $f_sname = (strtolower(trim($name)));
        $f_sname = $this->truncateString($f_sname, 15, false);
        //wykasowanie rozszerzenia pliku
        $f_sname = preg_replace('/\\.[^.\\s]{3,4}$/', '', $f_sname);

        //glowny trzon nazwy do ktorego beda dodawane numery w razie istnienia
        $f_sname_core = $f_sname;

        $x = 0;
        //czy taka nazwa jest wolna
        while ($this->is_name($user_id, $f_sname)) {
            $x++;
            //tworzenie nowej nazwy pliku
            $f_sname = "$x"."_".$f_sname_core;
        }

        $query = "INSERT INTO files (f_name, f_sname,f_type,f_size, f_content, user_id) VALUES('$name','$f_sname','$mime', '$size','$data', '$user_id')";
        $result = $this->db->sql_query($query);
    }

    //usuwanie
    public function delete($f_id) {
        $query = "DELETE FROM files WHERE f_id='$f_id'";
        $result = $this->db->sql_query($query);
    }

    //zlicz media usera
    public function count_media($user_id) {
        $query = "SELECT count(*) as total FROM files WHERE user_id='$user_id'";

        $result = $this->db->sql_query($query);
        if ($result) {
            $row = $this->db->sql_fetcharray($result);
            $row = $row['total'];
        }
        return $row;
    }

    //pokazanie mediow w katalogu
    public function show_media($user_id, $page = 0) {
        if ($page > 0) {
            $page = $page - 1;
        }
        //od jakiego rozpoczac
        $offset = $page * 10;

        $query = "SELECT * FROM files WHERE user_id='$user_id' LIMIT 10 OFFSET $offset";
        $result = $this->db->sql_query($query);
        if ($result) {
            $row = $this->db->sql_fetchassoc($result);
        }
        return $row;
    }

    //pokazanie pliku
    public function show_file($user, $f_id) {
        $uspass = $_COOKIE['password'];
        $ckey = $user['ckey'];

        $query = "SELECT * FROM files WHERE f_id='$f_id'";
        $result = $this->db->sql_query($query);
        if ($result) {
            $row = $this->db->sql_fetcharray($result);
        }
        $row['f_content'] = $this->DataEncrypt($row['f_content'], $uspass, $ckey);
        return $row;
    }

}

?>