<?php

/*
 * Core
 * klasa glowna
 */

class Core {
    /*
     * konstruktor
     */

    function __construct() {
        
    }

    /*
     * Obsluga adresow URL
     * adresy w formie index.php?0/modul/1
     * zwraca tablice kolejnych parametrow w url
     * podanie $section zwraca konkretny parametr z url
     */

    function niceUrl($section = "") {
        $section = "$section";
        $request = explode('?', $_SERVER['REQUEST_URI']);
        @$path = explode("/", $request[1]);
        return $path;
    }

    function DataCrypt($plaintext, $password, $ckey) {

        $k = md5($password . '' . $ckey);

        # the key should be random binary, use scrypt, bcrypt or PBKDF2 to
        # convert a string into a key
        # key is specified using hexadecimal
        $key = pack('H*', $k);

        # show key size use either 16, 24 or 32 byte keys for AES-128, 192
        # and 256 respectively
        $key_size = strlen($key);

        # create a random IV to use with CBC encoding
        $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC);
        $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);

        # creates a cipher text compatible with AES (Rijndael block size = 128)
        # to keep the text confidential 
        # only suitable for encoded input that never ends with value 00h
        # (because of default zero padding)
        $ciphertext = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $plaintext, MCRYPT_MODE_CBC, $iv);

        # prepend the IV for it to be available for decryption
        $ciphertext = $iv . $ciphertext;

        # encode the resulting cipher text so it can be represented by a string
        return base64_encode($ciphertext);
    }

    function DataEncrypt($ciphertext_base64, $password, $ckey) {
        $k = md5($password . '' . $ckey);

        $key = pack('H*', $k);


        $ciphertext_dec = base64_decode($ciphertext_base64);

        # create a random IV to use with CBC encoding
        $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC);
        $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);

        # retrieves the IV, iv_size should be created using mcrypt_get_iv_size()
        $iv_dec = substr($ciphertext_dec, 0, $iv_size);

        # retrieves the cipher text (everything except the $iv_size in the front)
        $ciphertext_dec = substr($ciphertext_dec, $iv_size);

        # may remove 00h valued characters from end of plain text
        $plaintext_dec = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $key, $ciphertext_dec, MCRYPT_MODE_CBC, $iv_dec);

        return rtrim($plaintext_dec);
    }

    //wyciaga dane z pomiedzy znacznikow
    function get_all_string_between($string, $start, $end) {
        $result = array();
        $string = " " . $string;
        $offset = 0;
        while (true) {
            $ini = strpos($string, $start, $offset);
            if ($ini == 0)
                break;
            $ini += strlen($start);
            $len = strpos($string, $end, $ini) - $ini;
            $result[] = substr($string, $ini, $len);
            $offset = $ini + $len;
        }
        return $result;
    }

    //robi hiperlinki do podstron z tekstu np [hello]
    function hiperlink($code) {
        $matches = $this->get_all_string_between($code, "[", "]");

        for ($x = 0; $x < count($matches); $x++) {
            $value = $matches[$x];
            $code = str_replace("[$value]", "<a href='index.php?Page/$value'>$value</a>", $code);
        }

        return $code;
    }

    //robi hiperlinki z tekstu np. http://wp.pl
    function dolink($code) {

        return preg_replace(
                array(
            '/(?(?=<a[^>]*>.+<\/a>)
                   (?:<a[^>]*>.+<\/a>)
                   |
                   ([^="\']?)((?:https?|ftp|bf2|):\/\/[^<> \n\r]+)
               )/iex',
            '/<a([^>]*)target="?[^"\']+"?/i',
            '/<a([^>]+)>/i',
            '/(^|\s)(www.[^<> \n\r]+)/iex',
            '/(([_A-Za-z0-9-]+)(\\.[_A-Za-z0-9-]+)*@([A-Za-z0-9-]+)
             (\\.[A-Za-z0-9-]+)*)/iex'
                ), array(
            "stripslashes((strlen('\\2')>0?'\\1<a href=\"\\2\">\\2</a>\\3':'\\0'))",
            '<a\\1',
            '<a\\1 target="_blank">',
            "stripslashes((strlen('\\2')>0?'\\1<a href=\"http://\\2\">\\2</a>\\3':'\\0'))",
            "stripslashes((strlen('\\2')>0?'<a href=\"mailto:\\0\">\\0</a>':'\\0'))"
                ), $code
        );
    }

}

?>
