    {literal}
        <script>

            function post_to_url(path, params, method) {
                method = method || "post"; // Set method to post by default, if not specified.

                var form = $(document.createElement("form"))
                        .attr({"method": method, "action": path});

                $.each(params, function (key, value) {
                    $.each(value instanceof Array ? value : [value], function (i, val) {
                        $(document.createElement("input"))
                                .attr({"type": "hidden", "name": key, "value": val})
                                .appendTo(form);
                    });
                });

                form.appendTo(document.body).submit();
            }

            $(document).ready(function () {
                
                $("#success_log").fadeOut(6000);

                $("#button_start").button({
                    icons: {
                        primary: "ui-icon-home"
                    }
                }).click(function (event) {
                    location.href = 'index.php?Page';
                });

                $("#button_page").button({
                    icons: {
                        primary: "ui-icon-newwin"
                    }
                }).click(function (event) {
                    post_to_url("index.php?Page", {add: ""});

                });

                $("#button_edit").button({
                    icons: {
                        primary: "ui-icon-document-b"
                    }
                }).click(function (event) {
                    post_to_url("index.php?Page", {p_id: "{/literal}{$MainPage.p_id}{literal}", edit: "{/literal}{$MainPage.p_id}{literal}"});
                });
                
                 $("#button_delete").button({
                    icons: {
                        primary: "ui-icon-trash"
                    }
                }).click(function (event) {
                    post_to_url("index.php?Page", {p_id: "{/literal}{$MainPage.p_id}{literal}", delete: "{/literal}{$MainPage.p_id}{literal}"});
                });

                $("#button_media").button({
                    icons: {
                        primary: "ui-icon-image"
                    }
                }).click(function (event) {
                    location.href = 'index.php?Media';
                });

                $("#button_config").button({
                    icons: {
                        primary: "ui-icon-wrench"
                    }
                }).click(function (event) {
                    location.href = 'index.php?Config';
                });


                $("#button_logout").button({
                    icons: {
                        primary: "ui-icon-power"
                    }
                }).click(function (event) {
                    location.href = 'index.php?Logout';
                });
                
                $("#button_search").button({
                    icons: {
                        primary: "ui-icon-search"
                    }
                }).click(function (event) {
                     $("#form_search").submit();
                });

            });
        </script>
    {/literal}

    <div id="main_panel">
        <div id="panel_logo">
            <b>SecretWiki</b>
        </div>
        <div id="panel_buttons">
            <form id="form_search" action="index.php?Search" method="post">
                <input type="text" name="phrase_search" id="phrase_search"/>
                <button id="button_search">Szukaj</button>
            </form>
            <button id="button_start">Start</button>
            <button id="button_page">Nowa</button>
            <button id="button_edit">Edytuj</button>
            <button id="button_delete">Usuń</button>
            <button id="button_media">Media</button>
            <button id="button_config">Konfiguruj</button>
            <button id="button_logout">Wyloguj</button>
        </div>
    </div>