<?php

require_once("application/Page/model/m_Page.php");
$STRONY = new Page($DB, 0);
$SMARTY->template_dir = 'application/Page/template';


$SMARTY->assign("BASE_CSS", "public/css/default.css");
$SMARTY->assign("USER_CSS", $USER->user_css());

if (!empty($USER->user_id)){
    //usuwanie strony
    if (isset($_POST['delete'])) {
        //pobranie id strony glownej
        $mp = $STRONY->GetMainPage($USER->user_id);
        //jesli nie jest strona glowna
        if ($mp['p_id']!=$_POST['p_id']){
            $STRONY->delete($_POST['p_id']);
            $SMARTY->assign('MESSAGE', '<div id="success_log">Strona została wykasowana!</div>');
        }
        //jesli jest strona glowna
        else{
            $SMARTY->assign('MESSAGE', '<div id="error_log">Brak mozliwosci wykasowania strony glownej!</div>');
        }
    }

    //zapisanie nowej strony
    if ($_POST['p_content'] != "" && $_POST['p_id'] == "") {
        $STRONY->add($USER->get($user_id = $USER->user_id), $_POST['p_title'], $_POST['p_content']);
        $SMARTY->assign('MESSAGE', '<div id="success_log">Strona została dodana!</div>');
    }

    //zapisanie edycji strony
    if ($_POST['p_content'] != "" && $_POST['p_id'] != "") {
        $STRONY->save($USER->get($user_id = $USER->user_id), $_POST['p_id'], $_POST['p_title'], $_POST['p_content']);
        $SMARTY->assign('MESSAGE', '<div id="success_log">Strona została zapisana!</div>');
    }

    //edycja strony
    if (isset($_POST['edit']) || isset($_POST['add'])) {
        if (isset($_POST['edit'])) {
            $SMARTY->assign('Page', $STRONY->show_page($USER->get($user_id = $USER->user_id), $_POST['p_id']));
        }
        $SMARTY->display('p_EditPage.tpl');

    } else {

        $u = $CORE->niceUrl();
        //strona glowna
        if ($u[1] == "") {
            $mp = $STRONY->GetMainPage($USER->user_id);
            $page = $STRONY->show_page($USER->get($user_id = $USER->user_id), $mp['p_id']);
            //stworzenie linkow
            $page['p_content'] = $CORE->dolink($page['p_content']);
            $page['p_content'] = $CORE->hiperlink($page['p_content']);
            $SMARTY->assign('MainPage', $page);
            $SMARTY->display('p_Page.tpl');
        //podstrony
        } else {
            $page = $STRONY->show_page($USER->get($user_id = $USER->user_id), $u[1]);
            //jesli strona nie istnieje
            if($page['p_id']==0){
                $page['p_title'] = $u[1];
                $page['p_content'] = "<h1>404</h1>Brak strony, możesz ją utworzyć.";
                $SMARTY->assign('Page',$page);
                $SMARTY->display('p_EditPage.tpl');                
            }
            //jesli strona istnieje
            else {
                //stworzenie linkow
                $page['p_content'] = $CORE->dolink($page['p_content']);
                $page['p_content'] = $CORE->hiperlink($page['p_content']);
                $SMARTY->assign('MainPage', $page);
                $SMARTY->display('p_Page.tpl');
            }
        }
    }
}
else {
    header("Location: index.php");
}
?>