<?php

class Page extends Core {

    public function __construct(&$db, $p_id) {
        $this->id = $p_id;
        $this->db = $db;
    }

    public function getData($table_field) {
        $zap = sprintf("SELECT %s FROM pages WHERE p_id='%d'", $table_field, $this->id);
        $result = $this->db->sql_fetcharray($this->db->sql_query($zap));
        while ($result) {
            return $result[$table_field];
        }
        //return "W budowie";
    }

    public function getDBData($table, $table_field, $id_n, $id) {
        $zap = sprintf("SELECT %s FROM %s WHERE %s='%d'", $table_field, $table, $id_n, $id);
        $result = $this->db->sql_fetcharray($this->db->sql_query($zap));
        while ($result) {
            return $result[$table_field];
        }
        //return "W budowie";
    }

    public function show_data($tabela, $ID, $wID, $content) {
        $query = sprintf("SELECT * FROM %s WHERE %s='%d'", $tabela, $ID, $wID);
        $result = $this->db->sql_query($query);
        if ($result) {
            $row = $this->db->sql_fetcharray($result);
            return $row[$content];
        }
        return "W budowie";
    }

    //pokazanie strony
    public function show_page($user, $page) {
        $uspass = $_COOKIE['password'];
        $ckey = $user['ckey'];
        
        //podano id strony
        if(is_numeric($page)){
            $query = "SELECT * FROM pages WHERE p_id=$page and user_id=$user[user_id]";
            @$result = $this->db->sql_query($query);
            if ($result) {
                $row = $this->db->sql_fetcharray($result);
                $row['p_title'] = $this->DataEncrypt($row['p_title'], $uspass, $ckey);
                $row['p_content'] = $this->DataEncrypt($row['p_content'], $uspass, $ckey);
            }
        }
        //podano tytul
        else {
            $query = "SELECT * FROM pages WHERE user_id=$user[user_id] ";
            $result = $this->db->sql_query($query);
            if ($result) {
                $row = $this->db->sql_fetchassoc($result);
                //poszukiwania
                $id = 0;
                for($x=0;$x<count($row);$x++){
                    $pt = $this->DataEncrypt($row[$x][p_title], $uspass, $ckey);
                    //znaleziono
                    if ($pt===$page){
                        $id = $row[$x][p_id];
                        break;
                    }
                }
                //jesli znaleziono
                if ($id>0){
                    $query = "SELECT * FROM pages WHERE p_id=$id and user_id=$user[user_id]";
                    @$result = $this->db->sql_query($query);
                    if ($result) {
                        $row = $this->db->sql_fetcharray($result);
                        $row['p_title'] = $this->DataEncrypt($row['p_title'], $uspass, $ckey);
                        $row['p_content'] = $this->DataEncrypt($row['p_content'], $uspass, $ckey);
                    }   
                }
            }
        }
        
        //brak strony
        if ($row['p_id']==0){
            $row['p_title'] = "404";
             $row['p_content'] = "Brak strony do wyswietlenia";
            return $row;
        }
        //jest strona
        else {
            return $row;
        }
        
    }

    //dodanie strony
    public function add($user, $p_title, $p_content) {
        $uspass = $_COOKIE['password'];
        $ckey = $user['ckey'];
        $user_id = $user['user_id'];
        $p_title = $this->DataCrypt($p_title, $uspass, $ckey);
        $p_content = $this->DataCrypt($p_content, $uspass, $ckey);

        $query = "INSERT INTO pages (user_id, p_title,p_content) VALUES('$user_id', '$p_title','$p_content')";
        $result = $this->db->sql_query($query);
    }

    //zapisanie edycji strony
    public function save($user, $p_id, $p_title, $p_content) {

        $uspass = $_COOKIE['password'];
        $ckey = $user['ckey'];
        $p_title = $this->DataCrypt($p_title, $uspass, $ckey);
        $p_content = $this->DataCrypt($p_content, $uspass, $ckey);

        $query = "UPDATE pages SET p_title='$p_title', p_content='$p_content' WHERE p_id='$p_id'";
        $this->db->sql_query($query);
    }

    //usuwanie strony
    public function delete($p_id) {
        $query = "DELETE FROM pages WHERE p_id=$p_id";
        $result = $this->db->sql_query($query);
    }

    function GetMainPage($user_id) {
        $query = "SELECT * FROM main_page WHERE user_id=$user_id";
        @$result = $this->db->sql_query($query);
        if ($result) {
            $row = $this->db->sql_fetcharray($result);
        }
        return $row;
    }

}

?>