{module_template file="s_header.tpl" module="Home"}


<div id="contentstarter">
    {literal}
    <!-- TinyMCE -->
    <script type="text/javascript" src="libs/tiny_mce/tinymce.min.js"></script>
    <script type="text/javascript">
        tinymce.init({
            browser_spellcheck: true,
            selector: "textarea",
            plugins: [
                "link image lists charmap print preview hr anchor pagebreak",
                "searchreplace wordcount visualblocks visualchars code fullscreen insertdatetime media nonbreaking",
                "table contextmenu directionality emoticons template textcolor paste textcolor"
            ],
            toolbar1: " code fullscreen | bold italic underline strikethrough | alignleft aligncenter alignright alignjustify | styleselect formatselect fontselect fontsizeselect",
            toolbar2: "cut copy paste | bullist numlist | link unlink image | forecolor backcolor | table | spellchecker |",
            menubar: false,
            toolbar_items_size: 'small',
            style_formats: [
                {title: 'Tytuł', block: 'h1'},
                {title: 'Tytuł rozdziału', block: 'h2'},
                {title: 'Kod programu', inline: 'span', classes: 'code'}
            ]
       });
    </script>
    <!-- /TinyMCE -->
    {/literal}

<div id="content">    
    <form method="POST" action="">

        <h2>Edycja strony</h2>
        <input type="hidden" name="p_id" value="{$Page.p_id}" />
        <table>
            <tr>
                <th>Tytuł:</th>
                <td><input type="text" name="p_title" value="{$Page.p_title}" size="50"/></td>
                <td><input type="submit" value="Zapisz" class="save" name="submit" /></td>
            </tr>
        </table>

        <textarea name="p_content" style="width: 500px; height:300px">{$Page.p_content}</textarea>
    </form>

</div>
</div>
{module_template file="s_footer.tpl" module="Home"}