
SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";

CREATE TABLE IF NOT EXISTS `files` (
`f_id` int(11) NOT NULL,
  `f_name` varchar(255) NOT NULL,
  `f_sname` varchar(18) NOT NULL COMMENT 'short name',
  `f_type` varchar(50) NOT NULL,
  `f_size` int(11) NOT NULL,
  `f_content` longblob NOT NULL,
  `user_id` int(11) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `main_page` (
`main_page_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `p_id` int(11) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `pages` (
`p_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `p_title` text NOT NULL,
  `p_content` text NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `user` (
`user_id` int(11) NOT NULL,
  `login` char(20) NOT NULL,
  `password` char(255) NOT NULL,
  `ckey` char(32) NOT NULL,
  `last_login` datetime NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `user_layout` (
`user_layout_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `bg_color` char(255) NOT NULL DEFAULT 'white',
  `bg_image` char(255) NOT NULL
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

ALTER TABLE `files`
 ADD PRIMARY KEY (`f_id`);

ALTER TABLE `main_page`
 ADD PRIMARY KEY (`main_page_id`);

ALTER TABLE `pages`
 ADD PRIMARY KEY (`p_id`);

ALTER TABLE `user`
 ADD PRIMARY KEY (`user_id`);

ALTER TABLE `user_layout`
 ADD PRIMARY KEY (`user_layout_id`);

ALTER TABLE `files`
MODIFY `f_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;

ALTER TABLE `main_page`
MODIFY `main_page_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;

ALTER TABLE `pages`
MODIFY `p_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;

ALTER TABLE `user`
MODIFY `user_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;

ALTER TABLE `user_layout`
MODIFY `user_layout_id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;
