<?php

ini_set('display_errors', 0);
ini_set('display_startup_errors', 0);
//error_reporting(E_ALL);

ob_start();
session_start();

require_once('config/config.php');

//dolaczam biblioteke smarty
require_once(SMARTY_PATH);
$SMARTY = new Smarty();

require_once ('core/dbclass.php');
$DB = new DB();

require('core/Core.php');
$CORE = new Core();

require('core/User.php');
$USER = new User($DB);

 
//----------------------Obsługa zawartości stron----------------------------
$table_url = $CORE->niceUrl();
$module = $table_url[0];

//strona tekstu
if ($module != "") {
        $SMARTY->template_dir = 'application/' . $module . '/template';
        include('application/' . $module . '/controller/c_' . $module . '.php');    
}
//strona glowna
else {
        if (@$USER->user_id != ""){
        $SMARTY->template_dir = 'application/Page/template';
        include('application/Page/controller/c_Page.php');
    }
    else {
        $SMARTY->template_dir = 'application/Home/template';
        include('application/Home/controller/c_Home.php');
    }
}
//----------------------END Obsługa zawartości stron----------------------------

ob_end_flush();
?>